class Singer : public IHumanCharacter
{
	public:

		// additional parts
		Part GuitarBack;
		Part HairBack;
		Part LeftShoeBack;
		Part LeftShin;
		Part LeftFoot;
		Part LeftShoe;
		Part RightShoeBack;
		Part RightShin;
		Part RightFoot;
		Part RightShoe;
		Part Neck;
		Part Dress;
		Part LeftEar;
		Part RightEar;
		Part LeftEyeBack;
		Part LeftEyeball;
		Part LeftEyebrow;
		Part RightEyeBack;
		Part RightEyeball;
		Part RightEyebrow;
		Part Nose;
		Part Hair;
		Part LeftForearm;
		Part LeftHand;
		Part Guitar;
		Part RightForearm;
		Part RightHand;

		// default constructor to register character, parts and decals
		Singer () : IHumanCharacter ()
		{
			GuitarBack.RegisterParent ( Guitar );
			Head.RegisterParent ( Neck );
			HairBack.RegisterParent ( Head );
			LeftShoeBack.RegisterParent ( LeftShoe );
			LeftShin.RegisterParent ( LeftLeg );
			LeftFoot.RegisterParent ( LeftShin );
			LeftShoe.RegisterParent ( LeftFoot );
			RightShoeBack.RegisterParent ( RightShoe );
			RightShin.RegisterParent ( RightLeg );
			RightFoot.RegisterParent ( RightShin );
			RightShoe.RegisterParent ( RightFoot );
			Neck.RegisterParent ( Body );
			Dress.RegisterParent ( Body );
			LeftEar.RegisterParent ( Head );
			RightEar.RegisterParent ( Head );
			LeftEyeBack.RegisterParent ( LeftEye );
			LeftEyeball.RegisterParent ( LeftEye );
			LeftEyebrow.RegisterParent ( LeftEye );
			RightEyeBack.RegisterParent ( RightEye );
			RightEyeball.RegisterParent ( RightEye );
			RightEyebrow.RegisterParent ( RightEye );
			Nose.RegisterParent ( Head );
			Hair.RegisterParent ( Head );
			LeftForearm.RegisterParent ( LeftArm );
			LeftHand.RegisterParent ( LeftForearm );
			Guitar.RegisterParent ( Body );
			RightForearm.RegisterParent ( RightArm );
			RightHand.RegisterParent ( RightForearm );

			Register ( 360, 360, 173, 354 );

			RegisterPart ( GuitarBack, "singer/GuitarBack.svg", 0, 0, 159, 174 );
			RegisterPart ( HairBack, "singer/HairBack.svg", 0, -27, 170, 40 );
			RegisterPart ( LeftArm, "singer/LeftArm.svg", 25, -80, 198, 89 );
			RegisterPart ( RightArm, "singer/RightArm.svg", -28, -82, 145, 87 );
			RegisterPart ( LeftShoeBack, "singer/LeftShoeBack.svg", -6, -2, 195, 338 );
			RegisterPart ( LeftLeg, "singer/LeftLeg.svg", 12, 20, 185, 189 );
			RegisterPart ( LeftShin, "singer/LeftShin.svg", 1, 58, 186, 247 );
			RegisterPart ( LeftFoot, "singer/LeftFoot.svg", -3, 82, 183, 329 );
			RegisterPart ( LeftShoe, "singer/LeftShoe.svg", 18, 11, 201, 340 );
			RegisterPart ( RightShoeBack, "singer/RightShoeBack.svg", 2, -1, 146, 338 );
			RegisterPart ( RightLeg, "singer/RightLeg.svg", -15, 29, 158, 198 );
			RegisterPart ( RightShin, "singer/RightShin.svg", 2, 50, 160, 248 );
			RegisterPart ( RightFoot, "singer/RightFoot.svg", 0, 81, 160, 329 );
			RegisterPart ( RightShoe, "singer/RightShoe.svg", -16, 10, 144, 339 );
			RegisterPart ( Body, "singer/Body.svg", 0, -185, 173, 169 );
			RegisterPart ( Neck, "singer/Neck.svg", -3, -84, 170, 85 );
			RegisterPart ( Dress, "singer/Dress.svg", -1, 19, 172, 188 );
			RegisterPart ( LeftEar, "singer/LeftEar.svg", 20, -22, 190, 45 );
			RegisterPart ( RightEar, "singer/RightEar.svg", -19, -21, 151, 46 );
			RegisterPart ( Head, "singer/Head.svg", 0, -18, 170, 67 );
			RegisterPart ( Mouth, "singer/Mouth.svg", 0, -3, 170, 64 );
			RegisterPart ( LeftEyeBack, "singer/LeftEyeBack.svg", 0, 2, 182, 40 );
			RegisterPart ( LeftEyeball, "singer/LeftEyeball.svg", -1, 2, 181, 40 );
			RegisterPart ( LeftEye, "singer/LeftEye.svg", 12, -29, 182, 38 );
			RegisterPart ( LeftEyebrow, "singer/LeftEyebrow.svg", 0, -7, 182, 31 );
			RegisterPart ( RightEyeBack, "singer/RightEyeBack.svg", 0, 1, 158, 40 );
			RegisterPart ( RightEyeball, "singer/RightEyeball.svg", 0, 1, 158, 40 );
			RegisterPart ( RightEye, "singer/RightEye.svg", -12, -28, 158, 39 );
			RegisterPart ( RightEyebrow, "singer/RightEyebrow.svg", -158, -39, 0, 0 );
			RegisterPart ( Nose, "singer/Nose.svg", 0, -13, 170, 54 );
			RegisterPart ( Hair, "singer/Hair.svg", 0, -51, 170, 16 );
			RegisterPart ( LeftForearm, "singer/LeftForearm.svg", 19, 56, 217, 145 );
			RegisterPart ( LeftHand, "singer/LeftHand.svg", -8, 47, 209, 192 );
			RegisterPart ( Guitar, "singer/Guitar.svg", -5, 15, 159, 174 );
			RegisterPart ( RightForearm, "singer/RightForearm.svg", -15, 60, 130, 147 );
			RegisterPart ( RightHand, "singer/RightHand.svg", 7, 46, 137, 193 );

			Mouth.RegisterDecal ( "SPEAK_M", "singer/Mouth_Speak_M.svg" );
			Mouth.RegisterDecal ( "SPEAK_E", "singer/Mouth_Speak_E.svg" );
			Mouth.RegisterDecal ( "SPEAK_A", "singer/Mouth_Speak_A.svg" );
			Mouth.RegisterDecal ( "SPEAK_O", "singer/Mouth_Speak_O.svg" );
			Mouth.RegisterDecal ( "SPEAK_W", "singer/Mouth_Speak_W.svg" );

			LeftEye.RegisterDecal ( "WINK1", "singer/LeftEye_Wink1.svg" );
			LeftEye.RegisterDecal ( "WINK2", "singer/LeftEye_Wink2.svg" );

			RightEye.RegisterDecal ( "WINK1", "singer/RightEye_Wink1.svg" );
			RightEye.RegisterDecal ( "WINK2", "singer/RightEye_Wink2.svg" );
		}
		
		void RightArmUp ()
		{
			RightArm.SetAngle ( 5 );
			RightForearm.SetAngle ( -50 );
		}

		void RightArmDown ()
		{
			RightArm.SetAngle ( 10 );
			RightForearm.SetAngle ( -20 );
		}
		
		void LeftArmChord1 ()
		{
			LeftArm.SetAngle ( -5 );
			LeftForearm.SetAngle ( -90 );
		}
		
		void LeftArmChord2 ()
		{
			LeftArm.SetAngle ( 0 );
			LeftForearm.SetAngle ( -95 );
		}
		
		void PlayChord ( double dDuration )
		{
			SetTime ( GetTime () );
			double dStep = dDuration / 4;
			
			LeftArmChord1 ();
			RightArmUp ();
			Sleep ( dStep );
			
			LeftArmChord1 ();
			RightArmDown ();
			Sleep ( dStep );			
			
			LeftArmChord2 ();
			RightArmUp ();
			Sleep ( dStep );
			
			LeftArmChord2 ();
			RightArmDown ();
			Sleep ( dStep );
		}
};
